MODULE modu 
  INTERFACE
    SUBROUTINE MPI_foo_expl(c1,c2,buf,test1,test2)
      IMPLICIT NONE
      !DEC$ ATTRIBUTES NO_ARG_CHECK :: buf 
      !$PRAGMA IGNORE_TKR buf
      !DIR$ IGNORE_TKR buf
      !IBM* IGNORE_TKR buf
      INTEGER c1, c2, buf(2), test1, test2 
    END SUBROUTINE MPI_foo_expl
  END INTERFACE
  INTERFACE
    SUBROUTINE MPI_foo_ex_c(c1,c2,buf,test1,test2) BIND(C)
      IMPLICIT NONE
      !DEC$ ATTRIBUTES NO_ARG_CHECK :: buf 
      !$PRAGMA IGNORE_TKR buf
      !DIR$ IGNORE_TKR buf
      !IBM* IGNORE_TKR buf
      INTEGER c1, c2, buf(2), test1, test2 
    END SUBROUTINE MPI_foo_ex_c
  END INTERFACE
END MODULE modu 
 
 
PROGRAM test
  USE modu 
  IMPLICIT NONE

  TYPE :: user_buffer_normal_type
    INTEGER :: VAL1
    INTEGER :: VAL2 
  END TYPE user_buffer_normal_type 
  TYPE(user_buffer_normal_type) :: buf_normal 

  TYPE :: user_buffer_sequence_type
    SEQUENCE 
    INTEGER :: VAL1
    INTEGER :: VAL2 
  END TYPE user_buffer_sequence_type
  TYPE(user_buffer_sequence_type) :: buf_sequence

  TYPE, BIND(C) :: user_buffer_bind_c_type
    INTEGER :: VAL1
    INTEGER :: VAL2 
  END TYPE user_buffer_bind_c_type 
  TYPE(user_buffer_bind_c_type) :: buf_bind_c 

  buf_normal%VAL1 = 11100
  buf_normal%VAL2 = 22201
  CALL MPI_foo_impl(1,1, buf_normal,       buf_normal%VAL1, buf_normal%VAL2) 
  buf_normal%VAL2 = 22202
  CALL MPI_foo_impl(1,2, buf_normal%VAL1,  buf_normal%VAL1, buf_normal%VAL2) 
  buf_normal%VAL2 = 22203
  CALL MPI_foo_expl(1,1, buf_normal,       buf_normal%VAL1, buf_normal%VAL2) 
  buf_normal%VAL2 = 22204
  CALL MPI_foo_expl(1,2, buf_normal%VAL1,  buf_normal%VAL1, buf_normal%VAL2) 
  buf_normal%VAL2 = 22205
  CALL MPI_foo_ex_c(1,1, buf_normal,       buf_normal%VAL1, buf_normal%VAL2) 
  buf_normal%VAL2 = 22206
  CALL MPI_foo_ex_c(1,2, buf_normal%VAL1,  buf_normal%VAL1, buf_normal%VAL2) 

  buf_sequence%VAL1 = 33300
  buf_sequence%VAL2 = 44401
  CALL MPI_foo_impl(2,1, buf_sequence,     buf_sequence%VAL1, buf_sequence%VAL2) 
  buf_sequence%VAL2 = 44402
  CALL MPI_foo_impl(2,2, buf_sequence%VAL1,buf_sequence%VAL1, buf_sequence%VAL2) 
  buf_sequence%VAL2 = 44403
  CALL MPI_foo_expl(2,1, buf_sequence,     buf_sequence%VAL1, buf_sequence%VAL2) 
  buf_sequence%VAL2 = 44404
  CALL MPI_foo_expl(2,2, buf_sequence%VAL1,buf_sequence%VAL1, buf_sequence%VAL2) 
  buf_sequence%VAL2 = 44405
  CALL MPI_foo_ex_c(2,1, buf_sequence,     buf_sequence%VAL1, buf_sequence%VAL2) 
  buf_sequence%VAL2 = 44406
  CALL MPI_foo_ex_c(2,2, buf_sequence%VAL1,buf_sequence%VAL1, buf_sequence%VAL2) 

  buf_bind_c%VAL1 = 55500
  buf_bind_c%VAL2 = 66601
  CALL MPI_foo_impl(3,1, buf_bind_c,       buf_bind_c%VAL1, buf_bind_c%VAL2) 
  buf_bind_c%VAL2 = 66602
  CALL MPI_foo_impl(3,2, buf_bind_c%VAL1,  buf_bind_c%VAL1, buf_bind_c%VAL2) 
  buf_bind_c%VAL2 = 66603
  CALL MPI_foo_expl(3,1, buf_bind_c,       buf_bind_c%VAL1, buf_bind_c%VAL2) 
  buf_bind_c%VAL2 = 66604
  CALL MPI_foo_expl(3,2, buf_bind_c%VAL1,  buf_bind_c%VAL1, buf_bind_c%VAL2) 
  buf_bind_c%VAL2 = 66605
  CALL MPI_foo_ex_c(3,1, buf_bind_c,       buf_bind_c%VAL1, buf_bind_c%VAL2) 
  buf_bind_c%VAL2 = 66606
  CALL MPI_foo_ex_c(3,2, buf_bind_c%VAL1,  buf_bind_c%VAL1, buf_bind_c%VAL2) 
 
END PROGRAM
